<?php

namespace App\Http\Controllers\V3\Dashboard\RoadPatrol;


use App\Enums\MissionStates;
use App\Exports\V3\RoadPatrols\OperatorCartableReport;
use App\Facades\Sms\Sms;
use App\Http\Controllers\Controller;
use App\Http\Requests\V3\RoadPatrol\DeleteRequest;
use App\Http\Requests\V3\RoadPatrol\StoreRequest;
use App\Http\Traits\ApiResponse;
use App\Models\EdarateShahri;
use App\Models\InfoItem;
use App\Models\Mission;
use App\Models\RoadItemsProject;
use App\Models\RoadPatrol;
use App\Services\Cartables\RoadPatrol\OperatorService;
use App\Services\NominatimService;
use Carbon\Carbon;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Storage;
use Illuminate\Validation\ValidationException;
use Maatwebsite\Excel\Facades\Excel;
use Symfony\Component\HttpFoundation\BinaryFileResponse;


class OperatorController extends Controller
{
    use ApiResponse;

    public function index(Request $request, OperatorService $operatorService): JsonResponse
    {
        $data = $operatorService->dataTable($request);
        return response()->json($data);
    }
    public function excel(Request $request, OperatorService $operatorService): BinaryFileResponse
    {
        $name = 'گزارش از کارتابل عملیات گشت راهداری ' . verta()->now()->format('Y-m-d H:i') . '.xlsx';
        $data = $operatorService->dataTable($request, true);
        return Excel::download(new OperatorCartableReport($data['data']), $name);
    }

    public function store(StoreRequest $request, NominatimService $nominatimService): JsonResponse
    {
        $user = auth()->user();

        $edare_id = $user->edarate_shahri_id ?? $user->edarate_ostani_id;
        $edare_name = $user->edarate_shahri_id ? $user->edarate_shahri_name : $user->edarate_ostani_name;

        $road_patrol = DB::transaction(function () use (
            $request, $edare_id,
            $edare_name, $nominatimService, $user
        ) {
            $mission = Mission::query()->findOrFail($request->mission_id);

            if ($mission->status !== MissionStates::START_MISSION->value) {
                throw ValidationException::withMessages([
                    'mission_id' => 'ماموریت انتخاب شده هنوز شروع نشده است.',
                ]);
            }

            $road_patrol = RoadPatrol::query()->create([
                'operator_id' => $user->id,
                'operator_name' => $user->name,
                'province_id' => $user->province_id,
                'province_fa' => $user->province_fa,
                'city_id' => $user->city_id,
                'city_fa' => $user->city_fa,
                'edare_id' => $edare_id,
                'edare_name' => $edare_name,
                'status' => 0,
                'status_fa' => 'در حال بررسی',
                'distance' => $request->distance,
                'start_time' => $request->start_time,
                'end_time' => $request->end_time,
                'description' => $request->description ?? null,
                'fuel_consumption' => $request->fuel_consumption,
                'vehicle_runtime' => $request->vehicle_runtime,
                'stop_points' => json_encode($request->stop_points),
            ]);

            $road_patrol->rahdaran()->attach($request->road_patrol_rahdaran_id);
            $road_patrol->cmmsMachines()->attach($request->road_patrol_machines_id);

            if ($request->observed_items) {
                foreach ($request->observed_items as $index => $item) {
                    $info_item = InfoItem::where('item', $item['item_id'])
                        ->where('sub_item', $item['sub_item_id'])
                        ->firstOrFail();

                    $item_start_coordinates = explode(',', $item['start_point']);

                    $observed_item = $road_patrol->observedItems()->create([
                        'item_id' => $info_item->item,
                        'item_name' => $info_item->item_str,
                        'sub_item_id' => $info_item->sub_item,
                        'sub_item_name' => $info_item->sub_item_str,
                        'local_name' => $item['local_name'],
                        'description' => $item['description'] ?? null,
                        'start_lat' => $item_start_coordinates[0],
                        'start_lon' => $item_start_coordinates[1],
                    ]);

                    $item_end_coordinates = null;
                    if ($item['instant_action'] == 0) {
                        $priority = [
                            1 => 'عادی',
                            2 => 'فوری',
                            3 => 'آنی',
                        ];
                        $observed_item->priority = $item['priority'];
                        $observed_item->priority_fa = $priority[$item['priority']];
                        $observed_item->save();
                    } elseif ($item['instant_action'] == 1) {
                        if ($info_item->needs_end_point) {
                            if (!isset($item['end_point'])) {
                                throw ValidationException::withMessages([
                                    "observed_items.$index.end_point" => __('validation.required', ['attribute' => 'end_point']),
                                ]);
                            }

                            $item_end_coordinates = explode(',', $item['end_point']);
                        }

                        $before_image = null;
                        $after_image = null;
                        if ($info_item->needs_image) {
                            if (!isset($item['before_image'])) {
                                throw ValidationException::withMessages([
                                    "observed_items.$index.before_image" => __('validation.required', ['attribute' => 'before_image']),
                                ]);
                            }
                            if (!isset($item['after_image'])) {
                                throw ValidationException::withMessages([
                                    "observed_items.$index.after_image" => __('validation.required', ['attribute' => 'after_image']),
                                ]);
                            }

                            $before_image = $item['before_image'];
                            $after_image = $item['after_image'];
                        }

                        $start_time = Carbon::createFromFormat('Y-m-d H:i', $request->start_time);
                        $end_time = Carbon::createFromFormat('Y-m-d H:i', $request->end_time);
                        $activity_date = $start_time->average($end_time);

                        $attributes = [
                            'start_lat' => $item_start_coordinates[0],
                            'start_lng' => $item_start_coordinates[1],
                            'end_lat' => $item_end_coordinates ? $item_end_coordinates[0] : null,
                            'end_lng' => $item_end_coordinates ? $item_end_coordinates[1] : null,
                            'item' => $info_item->item,
                            'item_fa' => $info_item->item_str,
                            'sub_item' => $info_item->sub_item,
                            'sub_item_fa' => $info_item->sub_item_str,
                            'sub_item_data' => $item['amount'],
                            'province_id' => $user->province_id,
                            'province_fa' => $user->province_fa,
                            'city_id' => $user->city_id,
                            'city_fa' => $user->city_fa,
                            'user_name' => $user->name,
                            'start_way_id' => $nominatimService->get_way_id_from_nominatim($item_start_coordinates[0], $item_start_coordinates[1]),
                            'end_way_id' => $item_end_coordinates ? $nominatimService->get_way_id_from_nominatim($item_end_coordinates[0], $item_end_coordinates[1]) : null,
                            'unit_fa' => $info_item->sub_item_unit,
                            'created_at_fa' => verta(Carbon::now())->format('Y-m-d H:i:s'),
                            'info_id' => $info_item->id,
                            'status' => 0,
                            'status_fa' => 'در حال بررسی',
                            'edarat_id' => $user->edarate_shahri_id,
                            'edarat_type' => EdarateShahri::class,
                            'edarat_name' => $user->edarate_shahri_name,
                            'activity_date' => $activity_date->format('Y-m-d'),
                            'activity_time' => $activity_date->format('H:i:s'),
                        ];

                        $road_item = RoadItemsProject::store($user, $attributes, $before_image, $after_image, $observed_item->id);

                        if ($road_item === -1) {
                            return $this->errorResponse('اقدام مربوطه قبلا رسیدگی شده است.');
                        }

                        $road_item->rahdaran()->attach($item['road_item_rahdaran_id']);
                        $road_item->cmmsMachines()->attach($item['road_item_machines_id']);
                    }
                }
            }

            auth()->user()->addActivityComplete(1147);

            Sms::sendSms($request->officer_phone_number,
                "گشت راهداری با کد یکتای $road_patrol->id در تاریخ " . verta(\Carbon\Carbon::now())->format('Y-m-d H:i:s') . " با شماره شما در سامانه RMS ثبت شد. \n لینک دریافت گزارش : \n https://rms.rmto.ir/v2/road_patrols/operator/report/$road_patrol->id"
            );
            return $road_patrol;
        });

        return $this->successResponse();
    }

    public function delete(DeleteRequest $request, RoadPatrol $roadPatrol): JsonResponse
    {
        if ($request->type == 1) {
            DB::transaction(function () use ($roadPatrol) {
                $roadPatrol->observedItems()->delete();
                $roadPatrol->delete();
            });
        } else {
            DB::transaction(function () use ($roadPatrol) {
                if ($roadPatrol->observedItems) {
                    foreach ($roadPatrol->observedItems as $index => $observed_item) {
                        if ($observed_item->roadItemProject) {
                            $road_item = $observed_item->roadItemProject;

                            if ($road_item->files()->exists()) {
                                Storage::delete('public/' . $road_item->files[0]->path);
                                Storage::delete('public/' . $road_item->files[1]->path);
                                $road_item->files()->delete();
                            }

                            $road_item->delete();
                        }

                        $observed_item->delete();
                    }
                }
                auth()->user()->addActivityComplete(1144);

                $roadPatrol->delete();
            });
        }

        return $this->successResponse();
    }
}
